"use strict";var NodeType,TokenType;function isDocument(e){return e.type===NodeType.Document}function isTable(e){return e.type===NodeType.Table}function isTableKey(e){return e.type===NodeType.TableKey}function isTableArray(e){return e.type===NodeType.TableArray}function isTableArrayKey(e){return e.type===NodeType.TableArrayKey}function isKeyValue(e){return e.type===NodeType.KeyValue}function isInlineArray(e){return e.type===NodeType.InlineArray}function isInlineItem(e){return e.type===NodeType.InlineItem}function isInlineTable(e){return e.type===NodeType.InlineTable}function isComment(e){return e.type===NodeType.Comment}function hasItems(e){return isDocument(e)||isTable(e)||isTableArray(e)||isInlineTable(e)||isInlineArray(e)}function hasItem(e){return isTableKey(e)||isTableArrayKey(e)||isInlineItem(e)}function isBlock(e){return isKeyValue(e)||isTable(e)||isTableArray(e)||isComment(e)}function iterator(e){return e[Symbol.iterator]()}Object.defineProperty(exports,"__esModule",{value:!0}),function(e){e.Document="Document",e.Table="Table",e.TableKey="TableKey",e.TableArray="TableArray",e.TableArrayKey="TableArrayKey",e.KeyValue="KeyValue",e.Key="Key",e.String="String",e.Integer="Integer",e.Float="Float",e.Boolean="Boolean",e.DateTime="DateTime",e.InlineArray="InlineArray",e.InlineItem="InlineItem",e.InlineTable="InlineTable",e.Comment="Comment"}(NodeType||(NodeType={}));class Cursor{constructor(e){this.iterator=e,this.index=-1,this.value=void 0,this.done=!1,this.peeked=null}next(){if(this.done)return done();const e=this.peeked||this.iterator.next();return this.index+=1,this.value=e.value,this.done=e.done,this.peeked=null,e}peek(){return this.done?done():this.peeked?this.peeked:(this.peeked=this.iterator.next(),this.peeked)}[Symbol.iterator](){return this}}function done(){return{value:void 0,done:!0}}function getSpan(e){return{lines:e.end.line-e.start.line+1,columns:e.end.column-e.start.column}}function createLocate(e){const t=findLines(e);return(e,n)=>({start:findPosition(t,e),end:findPosition(t,n)})}function findPosition(e,t){const n=Array.isArray(e)?e:findLines(e),r=n.findIndex(e=>e>=t)+1;return{line:r,column:t-(n[r-2]+1||0)}}function getLine(e,t){const n=findLines(e),r=n[t.line-2]||0,o=n[t.line-1]||e.length;return e.substr(r,o-r)}function findLines(e){const t=/[\r\n|\n]/g,n=[];let r;for(;null!=(r=t.exec(e));)n.push(r.index);return n.push(e.length+1),n}function clonePosition(e){return{line:e.line,column:e.column}}function cloneLocation(e){return{start:clonePosition(e.start),end:clonePosition(e.end)}}function zero(){return{line:1,column:0}}class ParseError extends Error{constructor(e,t,n){let r=`Error parsing TOML (${t.line}, ${t.column+1}):\n`;if(e){const n=getLine(e,t),o=`${whitespace(t.column)}^`;n&&(r+=`${n}\n${o}\n`)}super(r+=n),this.line=t.line,this.column=t.column}}function whitespace(e,t=" "){return t.repeat(e)}!function(e){e.Bracket="Bracket",e.Curly="Curly",e.Equal="Equal",e.Comma="Comma",e.Dot="Dot",e.Comment="Comment",e.Literal="Literal"}(TokenType||(TokenType={}));const IS_WHITESPACE=/\s/,IS_NEW_LINE=/(\r\n|\n)/,DOUBLE_QUOTE='"',SINGLE_QUOTE="'",SPACE=" ",ESCAPE="\\",IS_VALID_LEADING_CHARACTER=/[\w,\d,\",\',\+,\-,\_]/;function*tokenize(e){const t=new Cursor(iterator(e));t.next();const n=createLocate(e);for(;!t.done;){if(IS_WHITESPACE.test(t.value));else if("["===t.value||"]"===t.value)yield specialCharacter(t,n,TokenType.Bracket);else if("{"===t.value||"}"===t.value)yield specialCharacter(t,n,TokenType.Curly);else if("="===t.value)yield specialCharacter(t,n,TokenType.Equal);else if(","===t.value)yield specialCharacter(t,n,TokenType.Comma);else if("."===t.value)yield specialCharacter(t,n,TokenType.Dot);else if("#"===t.value)yield comment(t,n);else{const r=checkThree(e,t.index,SINGLE_QUOTE)||checkThree(e,t.index,DOUBLE_QUOTE);r?yield multiline(t,n,r,e):yield string(t,n,e)}t.next()}}function specialCharacter(e,t,n){return{type:n,raw:e.value,loc:t(e.index,e.index+1)}}function comment(e,t){const n=e.index;let r=e.value;for(;!e.peek().done&&!IS_NEW_LINE.test(e.peek().value);)e.next(),r+=e.value;return{type:TokenType.Comment,raw:r,loc:t(n,e.index+1)}}function multiline(e,t,n,r){const o=e.index;let a=n+n+n,l=a;for(e.next(),e.next(),e.next();!e.done&&!checkThree(r,e.index,n);)l+=e.value,e.next();if(e.done)throw new ParseError(r,findPosition(r,e.index),`Expected close of multiline string with ${a}, reached end of file`);return l+=a,e.next(),e.next(),{type:TokenType.Literal,raw:l,loc:t(o,e.index+1)}}function string(e,t,n){if(!IS_VALID_LEADING_CHARACTER.test(e.value))throw new ParseError(n,findPosition(n,e.index),`Unsupported character "${e.value}". Expected ALPHANUMERIC, ", ', +, -, or _`);const r=e.index;let o=e.value,a=e.value===DOUBLE_QUOTE,l=e.value===SINGLE_QUOTE;const i=e=>{if(e.peek().done)return!0;const t=e.peek().value;return!(a||l)&&(IS_WHITESPACE.test(t)||","===t||"."===t||"]"===t||"}"===t||"="===t)};for(;!e.done&&!i(e)&&(e.next(),e.value===DOUBLE_QUOTE&&(a=!a),e.value!==SINGLE_QUOTE||a||(l=!l),o+=e.value,!e.peek().done);){let t=e.peek().value;a&&e.value===ESCAPE&&(t===DOUBLE_QUOTE?(o+=DOUBLE_QUOTE,e.next()):t===ESCAPE&&(o+=ESCAPE,e.next()))}if(a||l)throw new ParseError(n,findPosition(n,r),`Expected close of string with ${a?DOUBLE_QUOTE:SINGLE_QUOTE}`);return{type:TokenType.Literal,raw:o,loc:t(r,e.index+1)}}function checkThree(e,t,n){return e[t]===n&&e[t+1]===n&&e[t+2]===n&&n}function last(e){return e[e.length-1]}function blank(){return Object.create(null)}function isString(e){return"string"==typeof e}function isInteger(e){return"number"==typeof e&&e%1==0}function isFloat(e){return"number"==typeof e&&!isInteger(e)}function isBoolean(e){return"boolean"==typeof e}function isDate(e){return"[object Date]"===Object.prototype.toString.call(e)}function isObject(e){return e&&"object"==typeof e&&!isDate(e)&&!Array.isArray(e)}function isIterable(e){return null!=e&&"function"==typeof e[Symbol.iterator]}function has(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function arraysEqual(e,t){if(e.length!==t.length)return!1;for(let n=0;n<e.length;n++)if(e[n]!==t[n])return!1;return!0}function datesEqual(e,t){return isDate(e)&&isDate(t)&&e.toISOString()===t.toISOString()}function pipe(e,...t){return t.reduce((e,t)=>t(e),e)}function stableStringify(e){if(isObject(e)){return`{${Object.keys(e).sort().map(t=>`${JSON.stringify(t)}:${stableStringify(e[t])}`).join(",")}}`}return Array.isArray(e)?`[${e.map(stableStringify).join(",")}]`:JSON.stringify(e)}function merge(e,t){const n=e.length,r=t.length;e.length=n+r;for(let o=0;o<r;o++)e[n+o]=t[o]}const TRIPLE_DOUBLE_QUOTE='"""',TRIPLE_SINGLE_QUOTE="'''",LF="\\n",CRLF="\\r\\n",IS_CRLF=/\r\n/g,IS_LF=/\n/g,IS_LEADING_NEW_LINE=/^(\r\n|\n)/,IS_LINE_ENDING_BACKSLASH=/\\\s*[\n\r\n]\s*/g;function parseString(e){return e.startsWith(TRIPLE_SINGLE_QUOTE)?pipe(trim(e,3),trimLeadingWhitespace):e.startsWith(SINGLE_QUOTE)?trim(e,1):e.startsWith(TRIPLE_DOUBLE_QUOTE)?pipe(trim(e,3),trimLeadingWhitespace,lineEndingBackslash,escapeNewLines,unescape):e.startsWith(DOUBLE_QUOTE)?pipe(trim(e,1),unescape):e}function unescape(e){const t=e.replace(/\\U[a-fA-F0-9]{8}/g,e=>{const t=parseInt(e.replace("\\U",""),16),n=String.fromCodePoint(t);return trim(JSON.stringify(n),1)});return JSON.parse(`"${t}"`)}function trim(e,t){return e.substr(t,e.length-2*t)}function trimLeadingWhitespace(e){return IS_LEADING_NEW_LINE.test(e)?e.substr(1):e}function escapeNewLines(e){return e.replace(IS_CRLF,CRLF).replace(IS_LF,LF)}function lineEndingBackslash(e){return e.replace(IS_LINE_ENDING_BACKSLASH,"")}const TRUE="true",FALSE="false",HAS_E=/e/i,IS_DIVIDER=/\_/g,IS_INF=/inf/,IS_NAN=/nan/,IS_HEX=/^0x/,IS_OCTAL=/^0o/,IS_BINARY=/^0b/,IS_FULL_DATE=/(\d{4})-(\d{2})-(\d{2})/,IS_FULL_TIME=/(\d{2}):(\d{2}):(\d{2})/;function*parseTOML(e){const t=tokenize(e),n=new Cursor(t);for(;!n.next().done;)yield*walkBlock(n,e)}function*walkBlock(e,t){if(e.value.type===TokenType.Comment)yield comment$1(e);else if(e.value.type===TokenType.Bracket)yield table(e,t);else{if(e.value.type!==TokenType.Literal)throw new ParseError(t,e.value.loc.start,`Unexpected token "${e.value.type}". Expected Comment, Bracket, or String`);yield*keyValue(e,t)}}function*walkValue(e,t){if(e.value.type===TokenType.Literal)e.value.raw[0]===DOUBLE_QUOTE||e.value.raw[0]===SINGLE_QUOTE?yield string$1(e):e.value.raw===TRUE||e.value.raw===FALSE?yield boolean(e):IS_FULL_DATE.test(e.value.raw)||IS_FULL_TIME.test(e.value.raw)?yield datetime(e,t):!e.peek().done&&e.peek().value.type===TokenType.Dot||IS_INF.test(e.value.raw)||IS_NAN.test(e.value.raw)||HAS_E.test(e.value.raw)&&!IS_HEX.test(e.value.raw)?yield float(e,t):yield integer(e);else if(e.value.type===TokenType.Curly)yield inlineTable(e,t);else{if(e.value.type!==TokenType.Bracket)throw new ParseError(t,e.value.loc.start,`Unrecognized token type "${e.value.type}". Expected String, Curly, or Bracket`);{const[n,r]=inlineArray(e,t);yield n,yield*r}}}function comment$1(e){return{type:NodeType.Comment,loc:e.value.loc,raw:e.value.raw}}function table(e,t){const n=e.peek().done||e.peek().value.type!==TokenType.Bracket?NodeType.Table:NodeType.TableArray,r=n===NodeType.Table;if(r&&"["!==e.value.raw)throw new ParseError(t,e.value.loc.start,`Expected table opening "[", found ${e.value.raw}`);if(!r&&("["!==e.value.raw||"["!==e.peek().value.raw))throw new ParseError(t,e.value.loc.start,`Expected array of tables opening "[[", found ${e.value.raw+e.peek().value.raw}`);const o=r?{type:NodeType.TableKey,loc:e.value.loc}:{type:NodeType.TableArrayKey,loc:e.value.loc};if(e.next(),n===NodeType.TableArray&&e.next(),e.done)throw new ParseError(t,o.loc.start,"Expected table key, reached end of file");for(o.item={type:NodeType.Key,loc:cloneLocation(e.value.loc),raw:e.value.raw,value:[parseString(e.value.raw)]};!e.peek().done&&e.peek().value.type===TokenType.Dot;){e.next();const t=e.value;e.next();const n=" ".repeat(t.loc.start.column-o.item.loc.end.column),r=" ".repeat(e.value.loc.start.column-t.loc.end.column);o.item.loc.end=e.value.loc.end,o.item.raw+=`${n}.${r}${e.value.raw}`,o.item.value.push(parseString(e.value.raw))}if(e.next(),r&&(e.done||"]"!==e.value.raw))throw new ParseError(t,e.done?o.item.loc.end:e.value.loc.start,`Expected table closing "]", found ${e.done?"end of file":e.value.raw}`);if(!r&&(e.done||e.peek().done||"]"!==e.value.raw||"]"!==e.peek().value.raw))throw new ParseError(t,e.done||e.peek().done?o.item.loc.end:e.value.loc.start,`Expected array of tables closing "]]", found ${e.done||e.peek().done?"end of file":e.value.raw+e.peek().value.raw}`);r||e.next(),o.loc.end=e.value.loc.end;let a=[];for(;!e.peek().done&&e.peek().value.type!==TokenType.Bracket;)e.next(),merge(a,[...walkBlock(e,t)]);return{type:r?NodeType.Table:NodeType.TableArray,loc:{start:clonePosition(o.loc.start),end:clonePosition(a.length?a[a.length-1].loc.end:o.loc.end)},key:o,items:a}}function keyValue(e,t){const n={type:NodeType.Key,loc:cloneLocation(e.value.loc),raw:e.value.raw,value:[parseString(e.value.raw)]};for(;!e.peek().done&&e.peek().value.type===TokenType.Dot;)e.next(),e.next(),n.loc.end=e.value.loc.end,n.raw+=`.${e.value.raw}`,n.value.push(parseString(e.value.raw));if(e.next(),e.done||e.value.type!==TokenType.Equal)throw new ParseError(t,e.done?n.loc.end:e.value.loc.start,`Expected "=" for key-value, found ${e.done?"end of file":e.value.raw}`);const r=e.value.loc.start.column;if(e.next(),e.done)throw new ParseError(t,n.loc.start,"Expected value for key-value, reached end of file");const[o,...a]=walkValue(e,t);return[{type:NodeType.KeyValue,key:n,value:o,loc:{start:clonePosition(n.loc.start),end:clonePosition(o.loc.end)},equals:r},...a]}function string$1(e){return{type:NodeType.String,loc:e.value.loc,raw:e.value.raw,value:parseString(e.value.raw)}}function boolean(e){return{type:NodeType.Boolean,loc:e.value.loc,value:e.value.raw===TRUE}}function datetime(e,t){let n,r=e.value.loc,o=e.value.raw;if(!e.peek().done&&e.peek().value.type===TokenType.Literal&&IS_FULL_DATE.test(o)&&IS_FULL_TIME.test(e.peek().value.raw)){const t=r.start;e.next(),r={start:t,end:e.value.loc.end},o+=` ${e.value.raw}`}if(!e.peek().done&&e.peek().value.type===TokenType.Dot){const n=r.start;if(e.next(),e.peek().done||e.peek().value.type!==TokenType.Literal)throw new ParseError(t,e.value.loc.end,"Expected fractional value for DateTime");e.next(),r={start:n,end:e.value.loc.end},o+=`.${e.value.raw}`}if(IS_FULL_DATE.test(o))n=new Date(o.replace(" ","T"));else{const[e]=(new Date).toISOString().split("T");n=new Date(`${e}T${o}`)}return{type:NodeType.DateTime,loc:r,raw:o,value:n}}function float(e,t){let n,r=e.value.loc,o=e.value.raw;if(IS_INF.test(o))n="-inf"===o?-1/0:1/0;else if(IS_NAN.test(o))n=NaN;else if(e.peek().done||e.peek().value.type!==TokenType.Dot)n=Number(o.replace(IS_DIVIDER,""));else{const a=r.start;if(e.next(),e.peek().done||e.peek().value.type!==TokenType.Literal)throw new ParseError(t,e.value.loc.end,"Expected fraction value for Float");e.next(),o+=`.${e.value.raw}`,r={start:a,end:e.value.loc.end},n=Number(o.replace(IS_DIVIDER,""))}return{type:NodeType.Float,loc:r,raw:o,value:n}}function integer(e){if("-0"===e.value.raw||"+0"===e.value.raw)return{type:NodeType.Integer,loc:e.value.loc,raw:e.value.raw,value:0};let t=10;IS_HEX.test(e.value.raw)?t=16:IS_OCTAL.test(e.value.raw)?t=8:IS_BINARY.test(e.value.raw)&&(t=2);const n=parseInt(e.value.raw.replace(IS_DIVIDER,"").replace(IS_OCTAL,"").replace(IS_BINARY,""),t);return{type:NodeType.Integer,loc:e.value.loc,raw:e.value.raw,value:n}}function inlineTable(e,t){if("{"!==e.value.raw)throw new ParseError(t,e.value.loc.start,`Expected "{" for inline table, found ${e.value.raw}`);const n={type:NodeType.InlineTable,loc:cloneLocation(e.value.loc),items:[]};for(e.next();!e.done&&(e.value.type!==TokenType.Curly||"}"!==e.value.raw);){if(e.value.type===TokenType.Comma){const r=n.items[n.items.length-1];if(!r)throw new ParseError(t,e.value.loc.start,'Found "," without previous value in inline table');r.comma=!0,r.loc.end=e.value.loc.start,e.next();continue}const[r]=walkBlock(e,t);if(r.type!==NodeType.KeyValue)throw new ParseError(t,e.value.loc.start,`Only key-values are supported in inline tables, found ${r.type}`);const o={type:NodeType.InlineItem,loc:cloneLocation(r.loc),item:r,comma:!1};n.items.push(o),e.next()}if(e.done||e.value.type!==TokenType.Curly||"}"!==e.value.raw)throw new ParseError(t,e.done?n.loc.start:e.value.loc.start,`Expected "}", found ${e.done?"end of file":e.value.raw}`);return n.loc.end=e.value.loc.end,n}function inlineArray(e,t){if("["!==e.value.raw)throw new ParseError(t,e.value.loc.start,`Expected "[" for inline array, found ${e.value.raw}`);const n={type:NodeType.InlineArray,loc:cloneLocation(e.value.loc),items:[]};let r=[];for(e.next();!e.done&&(e.value.type!==TokenType.Bracket||"]"!==e.value.raw);){if(e.value.type===TokenType.Comma){const r=n.items[n.items.length-1];if(!r)throw new ParseError(t,e.value.loc.start,'Found "," without previous value for inline array');r.comma=!0,r.loc.end=e.value.loc.start}else if(e.value.type===TokenType.Comment)r.push(comment$1(e));else{const[o,...a]=walkValue(e,t),l={type:NodeType.InlineItem,loc:cloneLocation(o.loc),item:o,comma:!1};n.items.push(l),merge(r,a)}e.next()}if(e.done||e.value.type!==TokenType.Bracket||"]"!==e.value.raw)throw new ParseError(t,e.done?n.loc.start:e.value.loc.start,`Expected "]", found ${e.done?"end of file":e.value.raw}`);return n.loc.end=e.value.loc.end,[n,r]}function traverse(e,t){function n(e,t){for(const n of e)r(n,t)}function r(e,o){const a=t[e.type];switch(a&&"function"==typeof a&&a(e,o),a&&a.enter&&a.enter(e,o),e.type){case NodeType.Document:n(e.items,e);break;case NodeType.Table:r(e.key,e),n(e.items,e);break;case NodeType.TableKey:r(e.item,e);break;case NodeType.TableArray:r(e.key,e),n(e.items,e);break;case NodeType.TableArrayKey:r(e.item,e);break;case NodeType.KeyValue:r(e.key,e),r(e.value,e);break;case NodeType.InlineArray:n(e.items,e);break;case NodeType.InlineItem:r(e.item,e);break;case NodeType.InlineTable:n(e.items,e);break;case NodeType.Key:case NodeType.String:case NodeType.Integer:case NodeType.Float:case NodeType.Boolean:case NodeType.DateTime:case NodeType.Comment:break;default:throw new Error(`Unrecognized node type "${e.type}"`)}a&&a.exit&&a.exit(e,o)}isIterable(e)?n(e,null):r(e,null)}const enter_offsets=new WeakMap,getEnter=e=>(enter_offsets.has(e)||enter_offsets.set(e,new WeakMap),enter_offsets.get(e)),exit_offsets=new WeakMap,getExit=e=>(exit_offsets.has(e)||exit_offsets.set(e,new WeakMap),exit_offsets.get(e));function replace(e,t,n,r){if(hasItems(t)){const e=t.items.indexOf(n);if(e<0)throw new Error("Could not find existing item in parent node for replace");t.items.splice(e,1,r)}else if(hasItem(t))t.item=r;else{if(!isKeyValue(t))throw new Error(`Unsupported parent type "${t.type}" for replace`);t.key===n?t.key=r:t.value=r}shiftNode(r,{lines:n.loc.start.line-r.loc.start.line,columns:n.loc.start.column-r.loc.start.column});const o=getSpan(n.loc),a=getSpan(r.loc);addOffset({lines:a.lines-o.lines,columns:a.columns-o.columns},getExit(e),r,n)}function insert(e,t,n,r){if(!hasItems(t))throw new Error(`Unsupported parent type "${t.type}" for insert`);let o,a;r=null!=r?r:t.items.length,isInlineArray(t)||isInlineTable(t)?({shift:o,offset:a}=insertInline(t,n,r)):({shift:o,offset:a}=insertOnNewLine(t,n,r)),shiftNode(n,o);const l=t.items[r-1],i=l&&getExit(e).get(l);i&&(a.lines+=i.lines,a.columns+=i.columns,isInlineItem(n)&&l&&t.items[r+1]&&(a.columns-=2),getExit(e).delete(l)),getExit(e).set(n,a)}function insertOnNewLine(e,t,n){if(!isBlock(t))throw new Error(`Incompatible child type "${t.type}"`);const r=e.items[n-1],o=isDocument(e)&&!e.items.length;e.items.splice(n,0,t);const a=r?{line:r.loc.end.line,column:isComment(r)?e.loc.start.column:r.loc.start.column}:clonePosition(e.loc.start),l=isTable(t)||isTableArray(t);let i=0;o||(i=l?2:1),a.line+=i;const s={lines:a.line-t.loc.start.line,columns:a.column-t.loc.start.column},c=getSpan(t.loc);return{shift:s,offset:{lines:c.lines+(i-1),columns:c.columns}}}function insertInline(e,t,n){if(!isInlineItem(t))throw new Error(`Incompatible child type "${t.type}"`);const r=null!=n?e.items[n-1]:last(e.items),o=null==n||n===e.items.length;e.items.splice(n,0,t);const a=!!r,l=!o,i=o&&!0===t.comma;a&&(r.comma=!0),l&&(t.comma=!0);const s=isInlineArray(e)&&perLine(e),c=r?{line:r.loc.end.line,column:s?isComment(r)?e.loc.start.column:r.loc.start.column:r.loc.end.column}:clonePosition(e.loc.start);let u=0;if(s)u=1;else{const e=2,t=1;c.column+=a?e:t}c.line+=u;const y={lines:c.line-t.loc.start.line,columns:c.column-t.loc.start.column},p=getSpan(t.loc);return{shift:y,offset:{lines:p.lines+(u-1),columns:p.columns+(a||l?2:0)+(i?1:0)}}}function remove(e,t,n){if(!hasItems(t))throw new Error(`Unsupported parent type "${t.type}" for remove`);let r=t.items.indexOf(n);if(r<0){if((r=t.items.findIndex(e=>hasItem(e)&&e.item===n))<0)throw new Error("Could not find node in parent for removal");n=t.items[r]}const o=t.items[r-1];let a=t.items[r+1];t.items.splice(r,1);let l=getSpan(n.loc);a&&isComment(a)&&a.loc.start.line===n.loc.end.line&&(l=getSpan({start:n.loc.start,end:a.loc.end}),a=t.items[r+1],t.items.splice(r,1));const i=o&&isInlineItem(o),s=o&&o.loc.end.line===n.loc.start.line,c=a&&a.loc.start.line===n.loc.end.line,u=i&&(s||c),y={lines:-(l.lines-(u?1:0)),columns:-l.columns};i&&s&&(y.columns-=2),i&&o&&!a&&(o.comma=!1);const p=o||t,d=o?getExit(e):getEnter(e),f=getExit(e),m=d.get(p);m&&(y.lines+=m.lines,y.columns+=m.columns);const T=f.get(n);T&&(y.lines+=T.lines,y.columns+=T.columns),d.set(p,y)}function applyBracketSpacing(e,t,n=!0){if(!n)return;if(!t.items.length)return;addOffset({lines:0,columns:1},getEnter(e),t);const r=last(t.items);addOffset({lines:0,columns:1},getExit(e),r)}function applyTrailingComma(e,t,n=!1){if(!n)return;if(!t.items.length)return;const r=last(t.items);r.comma=!0,addOffset({lines:0,columns:1},getExit(e),r)}function applyWrites(e){const t=getEnter(e),n=getExit(e),r={lines:0,columns:{}};function o(e){e.loc.start.line+=r.lines,e.loc.start.column+=r.columns[e.loc.start.line]||0;const n=t.get(e);n&&(r.lines+=n.lines,r.columns[e.loc.start.line]=(r.columns[e.loc.start.line]||0)+n.columns)}function a(e){e.loc.end.line+=r.lines,e.loc.end.column+=r.columns[e.loc.end.line]||0;const t=n.get(e);t&&(r.lines+=t.lines,r.columns[e.loc.end.line]=(r.columns[e.loc.end.line]||0)+t.columns)}const l={enter:o,exit:a};traverse(e,{[NodeType.Document]:l,[NodeType.Table]:l,[NodeType.TableArray]:l,[NodeType.InlineTable]:l,[NodeType.InlineArray]:l,[NodeType.InlineItem]:l,[NodeType.TableKey]:l,[NodeType.TableArrayKey]:l,[NodeType.KeyValue]:{enter(e){const t=e.loc.start.line+r.lines,a=n.get(e.key);e.equals+=(r.columns[t]||0)+(a?a.columns:0),o(e)},exit:a},[NodeType.Key]:l,[NodeType.String]:l,[NodeType.Integer]:l,[NodeType.Float]:l,[NodeType.Boolean]:l,[NodeType.DateTime]:l,[NodeType.Comment]:l}),enter_offsets.delete(e),exit_offsets.delete(e)}function shiftNode(e,t,n={}){const{first_line_only:r=!1}=n,o=e.loc.start.line,{lines:a,columns:l}=t,i=e=>{r&&e.loc.start.line!==o||(e.loc.start.column+=l,e.loc.end.column+=l),e.loc.start.line+=a,e.loc.end.line+=a};return traverse(e,{[NodeType.Table]:i,[NodeType.TableKey]:i,[NodeType.TableArray]:i,[NodeType.TableArrayKey]:i,[NodeType.KeyValue](e){i(e),e.equals+=l},[NodeType.Key]:i,[NodeType.String]:i,[NodeType.Integer]:i,[NodeType.Float]:i,[NodeType.Boolean]:i,[NodeType.DateTime]:i,[NodeType.InlineArray]:i,[NodeType.InlineItem]:i,[NodeType.InlineTable]:i,[NodeType.Comment]:i}),e}function perLine(e){if(!e.items.length)return!1;return getSpan(e.loc).lines>e.items.length}function addOffset(e,t,n,r){const o=t.get(r||n);o&&(e.lines+=o.lines,e.columns+=o.columns),t.set(n,e)}function generateDocument(){return{type:NodeType.Document,loc:{start:zero(),end:zero()},items:[]}}function generateTable(e){const t=generateTableKey(e);return{type:NodeType.Table,loc:cloneLocation(t.loc),key:t,items:[]}}function generateTableKey(e){const t=keyValueToRaw(e);return{type:NodeType.TableKey,loc:{start:zero(),end:{line:1,column:t.length+2}},item:{type:NodeType.Key,loc:{start:{line:1,column:1},end:{line:1,column:t.length+1}},value:e,raw:t}}}function generateTableArray(e){const t=generateTableArrayKey(e);return{type:NodeType.TableArray,loc:cloneLocation(t.loc),key:t,items:[]}}function generateTableArrayKey(e){const t=keyValueToRaw(e);return{type:NodeType.TableArrayKey,loc:{start:zero(),end:{line:1,column:t.length+4}},item:{type:NodeType.Key,loc:{start:{line:1,column:2},end:{line:1,column:t.length+2}},value:e,raw:t}}}function generateKeyValue(e,t){const n=generateKey(e),{column:r}=n.loc.end,o=r+1;return shiftNode(t,{lines:0,columns:r+3-t.loc.start.column},{first_line_only:!0}),{type:NodeType.KeyValue,loc:{start:clonePosition(n.loc.start),end:clonePosition(t.loc.end)},key:n,equals:o,value:t}}const IS_BARE_KEY=/[\w,\d,\_,\-]+/;function keyValueToRaw(e){return e.map(e=>IS_BARE_KEY.test(e)?e:JSON.stringify(e)).join(".")}function generateKey(e){const t=keyValueToRaw(e);return{type:NodeType.Key,loc:{start:zero(),end:{line:1,column:t.length}},raw:t,value:e}}function generateString(e){const t=JSON.stringify(e);return{type:NodeType.String,loc:{start:zero(),end:{line:1,column:t.length}},raw:t,value:e}}function generateInteger(e){const t=e.toString();return{type:NodeType.Integer,loc:{start:zero(),end:{line:1,column:t.length}},raw:t,value:e}}function generateFloat(e){const t=e.toString();return{type:NodeType.Float,loc:{start:zero(),end:{line:1,column:t.length}},raw:t,value:e}}function generateBoolean(e){return{type:NodeType.Boolean,loc:{start:zero(),end:{line:1,column:e?4:5}},value:e}}function generateDateTime(e){const t=e.toISOString();return{type:NodeType.DateTime,loc:{start:zero(),end:{line:1,column:t.length}},raw:t,value:e}}function generateInlineArray(){return{type:NodeType.InlineArray,loc:{start:zero(),end:{line:1,column:2}},items:[]}}function generateInlineItem(e){return{type:NodeType.InlineItem,loc:cloneLocation(e.loc),item:e,comma:!1}}function generateInlineTable(){return{type:NodeType.InlineTable,loc:{start:zero(),end:{line:1,column:2}},items:[]}}function formatTopLevel(e){return e.items.filter(e=>{if(!isKeyValue(e))return!1;const t=isInlineTable(e.value),n=isInlineArray(e.value)&&e.value.items.length&&isInlineTable(e.value.items[0].item);return t||n}).forEach(t=>{remove(e,e,t),isInlineTable(t.value)?insert(e,e,formatTable(t)):formatTableArray(t).forEach(t=>{insert(e,e,t)})}),applyWrites(e),e}function formatTable(e){const t=generateTable(e.key.value);for(const n of e.value.items)insert(t,t,n.item);return applyWrites(t),t}function formatTableArray(e){const t=generateDocument();for(const n of e.value.items){const r=generateTableArray(e.key.value);insert(t,t,r);for(const e of n.item.items)insert(t,r,e.item)}return applyWrites(t),t.items}function formatPrintWidth(e,t){return e}function formatEmptyLines(e){let t=0,n=0;for(const r of e.items)0===n&&r.loc.start.line>1?t=1-r.loc.start.line:r.loc.start.line+t>n+2&&(t+=n+2-(r.loc.start.line+t)),shiftNode(r,{lines:t,columns:0}),n=r.loc.end.line;return e}const default_format={printWidth:80,trailingComma:!1,bracketSpacing:!0};function parseJS(e,t={}){t=Object.assign({},default_format,t),e=toJSON(e);const n=generateDocument();for(const r of walkObject(e,t))insert(n,n,r);return applyWrites(n),pipe(n,formatTopLevel,e=>formatPrintWidth(e),formatEmptyLines)}function*walkObject(e,t){for(const n of Object.keys(e))yield generateKeyValue([n],walkValue$1(e[n],t))}function walkValue$1(e,t){if(null==e)throw new Error('"null" and "undefined" values are not supported');return isString(e)?generateString(e):isInteger(e)?generateInteger(e):isFloat(e)?generateFloat(e):isBoolean(e)?generateBoolean(e):isDate(e)?generateDateTime(e):Array.isArray(e)?walkInlineArray(e,t):walkInlineTable(e,t)}function walkInlineArray(e,t){const n=generateInlineArray();for(const r of e){insert(n,n,generateInlineItem(walkValue$1(r,t)))}return applyBracketSpacing(n,n,t.bracketSpacing),applyTrailingComma(n,n,t.trailingComma),applyWrites(n),n}function walkInlineTable(e,t){if(!isObject(e=toJSON(e)))return walkValue$1(e,t);const n=generateInlineTable(),r=[...walkObject(e,t)];for(const e of r){insert(n,n,generateInlineItem(e))}return applyBracketSpacing(n,n,t.bracketSpacing),applyTrailingComma(n,n,t.trailingComma),applyWrites(n),n}function toJSON(e){return e&&!isDate(e)&&"function"==typeof e.toJSON?e.toJSON():e}const BY_NEW_LINE=/(\r\n|\n)/g;function toTOML(e,t="\n"){const n=[];return traverse(e,{[NodeType.TableKey](e){const{start:t,end:r}=e.loc;write(n,{start:t,end:{line:t.line,column:t.column+1}},"["),write(n,{start:{line:r.line,column:r.column-1},end:r},"]")},[NodeType.TableArrayKey](e){const{start:t,end:r}=e.loc;write(n,{start:t,end:{line:t.line,column:t.column+2}},"[["),write(n,{start:{line:r.line,column:r.column-2},end:r},"]]")},[NodeType.KeyValue](e){const{start:{line:t}}=e.loc;write(n,{start:{line:t,column:e.equals},end:{line:t,column:e.equals+1}},"=")},[NodeType.Key](e){write(n,e.loc,e.raw)},[NodeType.String](e){write(n,e.loc,e.raw)},[NodeType.Integer](e){write(n,e.loc,e.raw)},[NodeType.Float](e){write(n,e.loc,e.raw)},[NodeType.Boolean](e){write(n,e.loc,e.value.toString())},[NodeType.DateTime](e){write(n,e.loc,e.raw)},[NodeType.InlineArray](e){const{start:t,end:r}=e.loc;write(n,{start:t,end:{line:t.line,column:t.column+1}},"["),write(n,{start:{line:r.line,column:r.column-1},end:r},"]")},[NodeType.InlineTable](e){const{start:t,end:r}=e.loc;write(n,{start:t,end:{line:t.line,column:t.column+1}},"{"),write(n,{start:{line:r.line,column:r.column-1},end:r},"}")},[NodeType.InlineItem](e){if(!e.comma)return;const t=e.loc.end;write(n,{start:t,end:{line:t.line,column:t.column+1}},",")},[NodeType.Comment](e){write(n,e.loc,e.raw)}}),n.join(t)+t}function write(e,t,n){const r=n.split(BY_NEW_LINE),o=t.end.line-t.start.line+1;if(r.length!==o)throw new Error(`Mismatch between location and raw string, expected ${o} lines for "${n}"`);for(let n=t.start.line;n<=t.end.line;n++){const o=getLine$1(e,n),a=n===t.start.line,l=n===t.end.line,i=a?o.substr(0,t.start.column).padEnd(t.start.column,SPACE):"",s=l?o.substr(t.end.column):"";e[n-1]=i+r[n-t.start.line]+s}}function getLine$1(e,t){if(!e[t-1])for(let n=0;n<t;n++)e[n]||(e[n]="");return e[t-1]}function toJS(e,t=""){const n=blank(),r=new Set,o=new Set,a=new Set;let l,i=n,s=!1;return traverse(e,{[NodeType.Table](e){const l=e.key.item.value;try{validateKey(n,l,e.type,{tables:r,table_arrays:o,defined:a})}catch(n){throw new ParseError(t,e.key.loc.start,n.message)}const s=joinKey(l);r.add(s),a.add(s),i=ensureTable(n,l)},[NodeType.TableArray](e){const l=e.key.item.value;try{validateKey(n,l,e.type,{tables:r,table_arrays:o,defined:a})}catch(n){throw new ParseError(t,e.key.loc.start,n.message)}const s=joinKey(l);o.add(s),a.add(s),i=ensureTableArray(n,l)},[NodeType.KeyValue]:{enter(e){if(s)return;const n=e.key.value;try{validateKey(i,n,e.type,{tables:r,table_arrays:o,defined:a})}catch(n){throw new ParseError(t,e.key.loc.start,n.message)}const c=toValue(e.value);(n.length>1?ensureTable(i,n.slice(0,-1)):i)[last(n)]=c,a.add(joinKey(n)),isInlineTable(e.value)&&(l=i,i=c)},exit(e){isInlineTable(e.value)&&(i=l)}},[NodeType.InlineTable]:{enter(){s=!0},exit(){s=!1}}}),n}function toValue(e){switch(e.type){case NodeType.InlineTable:const t=blank();return e.items.forEach(({item:e})=>{const n=e.key.value,r=toValue(e.value);(n.length>1?ensureTable(t,n.slice(0,-1)):t)[last(n)]=r}),t;case NodeType.InlineArray:return e.items.map(e=>toValue(e.item));case NodeType.String:case NodeType.Integer:case NodeType.Float:case NodeType.Boolean:case NodeType.DateTime:return e.value;default:throw new Error(`Unrecognized value type "${e.type}"`)}}function validateKey(e,t,n,r){let o=[],a=0;for(const n of t){if(o.push(n),!has(e,n))return;if(isPrimitive(e[n]))throw new Error(`Invalid key, a value has already been defined for ${o.join(".")}`);const l=joinKey(o);if(Array.isArray(e[n])&&!r.table_arrays.has(l))throw new Error(`Invalid key, cannot add to a static array at ${l}`);const i=a++<t.length-1;e=Array.isArray(e[n])&&i?last(e[n]):e[n]}const l=joinKey(t);if(e&&n===NodeType.Table&&r.defined.has(l))throw new Error(`Invalid key, a table has already been defined named ${l}`);if(e&&n===NodeType.TableArray&&!r.table_arrays.has(l))throw new Error(`Invalid key, cannot add an array of tables to a table at ${l}`)}function ensureTable(e,t){const n=ensure(e,t.slice(0,-1)),r=last(t);return n[r]||(n[r]=blank()),n[r]}function ensureTableArray(e,t){const n=ensure(e,t.slice(0,-1)),r=last(t);n[r]||(n[r]=[]);const o=blank();return n[last(t)].push(o),o}function ensure(e,t){return t.reduce((e,t)=>(e[t]||(e[t]=blank()),Array.isArray(e[t])?last(e[t]):e[t]),e)}function isPrimitive(e){return"object"!=typeof e&&!isDate(e)}function joinKey(e){return e.join(".")}var ChangeType;function isAdd(e){return e.type===ChangeType.Add}function isEdit(e){return e.type===ChangeType.Edit}function isRemove(e){return e.type===ChangeType.Remove}function isMove(e){return e.type===ChangeType.Move}function isRename(e){return e.type===ChangeType.Rename}function diff(e,t,n=[]){return e===t||datesEqual(e,t)?[]:Array.isArray(e)&&Array.isArray(t)?compareArrays(e,t,n):isObject(e)&&isObject(t)?compareObjects(e,t,n):[{type:ChangeType.Edit,path:n}]}function compareObjects(e,t,n=[]){let r=[];const o=Object.keys(e),a=o.map(t=>stableStringify(e[t])),l=Object.keys(t),i=l.map(e=>stableStringify(t[e])),s=(e,t)=>{if(t.indexOf(e)<0)return!1;const n=o[a.indexOf(e)];return!l.includes(n)};return o.forEach((o,c)=>{const u=n.concat(o);if(l.includes(o))merge(r,diff(e[o],t[o],u));else if(s(a[c],i)){const e=l[i.indexOf(a[c])];r.push({type:ChangeType.Rename,path:n,from:o,to:e})}else r.push({type:ChangeType.Remove,path:u})}),l.forEach((e,t)=>{o.includes(e)||s(i[t],a)||r.push({type:ChangeType.Add,path:n.concat(e)})}),r}function compareArrays(e,t,n=[]){let r=[];const o=e.map(stableStringify),a=t.map(stableStringify);a.forEach((l,i)=>{const s=i>=o.length;if(!s&&o[i]===l)return;const c=o.indexOf(l,i+1);if(!s&&c>-1){r.push({type:ChangeType.Move,path:n,from:c,to:i});const e=o.splice(c,1);return void o.splice(i,0,...e)}const u=!a.includes(o[i]);if(!s&&u)return merge(r,diff(e[i],t[i],n.concat(i))),void(o[i]=l);r.push({type:ChangeType.Add,path:n.concat(i)}),o.splice(i,0,l)});for(let e=a.length;e<o.length;e++)r.push({type:ChangeType.Remove,path:n.concat(e)});return r}function findByPath(e,t){if(!t.length)return e;if(isKeyValue(e))return findByPath(e.value,t);const n={};let r;if(hasItems(e)&&e.items.some((e,o)=>{try{let a=[];if(isKeyValue(e))a=e.key.value;else if(isTable(e))a=e.key.item.value;else if(isTableArray(e)){const t=stableStringify(a=e.key.item.value);n[t]||(n[t]=0);const r=n[t]++;a=a.concat(r)}else isInlineItem(e)&&isKeyValue(e.item)?a=e.item.key.value:isInlineItem(e)&&(a=[o]);return!(!a.length||!arraysEqual(a,t.slice(0,a.length)))&&(r=findByPath(e,t.slice(a.length)),!0)}catch(e){return!1}}),!r)throw new Error(`Could not find node at path ${t.join(".")}`);return r}function tryFindByPath(e,t){try{return findByPath(e,t)}catch(e){}}function findParent(e,t){let n,r=t;for(;r.length&&!n;)n=tryFindByPath(e,r=r.slice(0,-1));if(!n)throw new Error(`Count not find parent node for path ${t.join(".")}`);return n}function patch(e,t,n){const r=[...parseTOML(e)],o=toJS(r);return toTOML(applyChanges({type:NodeType.Document,loc:{start:{line:1,column:0},end:{line:1,column:0}},items:r},parseJS(t,n),diff(o,t)).items)}function applyChanges(e,t,n){return n.forEach(n=>{if(isAdd(n)){const r=findByPath(t,n.path),o=n.path.slice(0,-1);let a,l=last(n.path),i=isTableArray(r);if(isInteger(l)&&!o.some(isInteger)){const t=tryFindByPath(e,o.concat(0));t&&isTableArray(t)&&(i=!0)}if(isTable(r))a=e;else if(i){a=e;const t=e,n=tryFindByPath(t,o.concat(l-1)),r=tryFindByPath(t,o.concat(l));l=r?t.items.indexOf(r):n?t.items.indexOf(n)+1:t.items.length}else isKeyValue(a=findParent(e,n.path))&&(a=a.value);isTableArray(a)||isInlineArray(a)||isDocument(a)?insert(e,a,r,l):insert(e,a,r)}else if(isEdit(n)){let r,o=findByPath(e,n.path),a=findByPath(t,n.path);isKeyValue(o)&&isKeyValue(a)?(r=o,o=o.value,a=a.value):r=findParent(e,n.path),replace(e,r,o,a)}else if(isRemove(n)){let t=findParent(e,n.path);isKeyValue(t)&&(t=t.value);const r=findByPath(e,n.path);remove(e,t,r)}else if(isMove(n)){let t=findByPath(e,n.path);hasItem(t)&&(t=t.item),isKeyValue(t)&&(t=t.value);const r=t.items[n.from];remove(e,t,r),insert(e,t,r,n.to)}else if(isRename(n)){let r=findByPath(e,n.path.concat(n.from)),o=findByPath(t,n.path.concat(n.to));hasItem(r)&&(r=r.item),hasItem(o)&&(o=o.item),replace(e,r,r.key,o.key)}}),applyWrites(e),e}function parse(e){return toJS(parseTOML(e),e)}function stringify(e,t){return toTOML(parseJS(e,t).items)}!function(e){e.Add="Add",e.Edit="Edit",e.Remove="Remove",e.Move="Move",e.Rename="Rename"}(ChangeType||(ChangeType={})),exports.parse=parse,exports.patch=patch,exports.stringify=stringify;
//# sourceMappingURL=toml-patch.cjs.min.js.map
